/*
* COMPONENT_NAME: ldap.clients
*
* ABSTRACT: Used when compiling win32 sample clients
*
* ORIGINS: 202,27
*
* (C) COPYRIGHT International Business Machines Corp. 1997, 2002
* All Rights Reserved
* Licensed Materials - Property of IBM
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

#if defined(WIN32)
#include <stdio.h>
#include <ctype.h>
#include <string.h>

char *optarg;
int optind = 1;
int optopt;

int getopt (int, char**, char*);


int getopt(int argc, char **argv, char *ostr) {

#define EMSG ""

   static char *place = EMSG;
   register char *oli;

   if (!*place) {
      if (optind >= argc || *(place = argv[optind]) != '-' || !*++place) {
         return EOF;
      }
      if (*place == '-') {
         ++optind;
         return EOF;
      }
   }
   if ((optopt = (int) * place++) == (int)':' || !(oli = strchr(ostr, optopt))) {
      if (!*place) {
         ++optind;
      }
      fprintf(stderr, "%s: %s: %c\n", "getopt", "illegal option", optopt);
      return ( '?' );
   }
   if (*++oli != ':') {
      optarg = NULL;
      if (!*place)
         ++optind;
   } else {
      if (*place) {
         optarg = place;
      } else if (argc <= ++optind) {
         place = EMSG;
         fprintf(stderr, "%s: %s: %c\n", "getopt", "option requires an argument", optopt);
         return 0;
      } else {
         optarg = argv[optind];
      }
      place = EMSG;
      ++optind;
   }
   return optopt;
}


#endif
