#
# @(#)51 1.4.3.13  src/clients/tools/makefile.x86_nt_4, ldap.clients, aus52ldap 5/11/03 15:13:33
#
#-----------------------------------------------------------------------------
#
# COMPONENT_NAME: examples
#
# ABSTRACT: makefile to generate the example LDAP client programs
#
# ORIGINS: 202,27
#
# (C) COPYRIGHT International Business Machines Corp. 1997, 1998, 2001
# All Rights Reserved
# Licensed Materials - Property of IBM
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#-----------------------------------------------------------------------------
# Copyright (c) 1994 Regents of the University of Michigan.
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that this notice is preserved and that due credit is given
# to the University of Michigan at Ann Arbor. The name of the University
# may not be used to endorse or promote products derived from this
# software without specific prior written permission. This software
# is provided ``as is'' without express or implied warranty.
#-----------------------------------------------------------------------------
#
# This makefile will build the example programs whose source is contained
# in this directory.  The four programs generated are:
#  ldapsearch
#  ldapmodify
#  ldapadd (a hard-link to ldapmodify)
#  ldapmodrdn
#  ldapdelete
#  ldapchangepwd
#  ldapexop
# In addition to being examples of the use of the LDAP client api, these
# programs are useful command line utilities.  See the LDAP Programming
# Reference for more details.

#
# default definitions for client utilities (may be changed here)
CC	= cl.exe
LD      = link.exe
RM	= del /f
HARDLN	= copy

#############################################################################
## General compiler options                                                ##
#############################################################################

DEFINES	= /DNDEBUG /DWIN32 /D_CONSOLE /D_MBCS /DNT
INCLUDES= /I../include
CFLAGS	= /nologo /MD /GX /O2 $(INCLUDES) $(DEFINES)

#############################################################################
## General linker options                                                  ##
#############################################################################

LIBS    = kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib\
 advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib\
 odbccp32.lib wsock32.lib

# Use the following definition to link the sample programs statically.
#CLIENT_LIBS = ldapstatic.lib libldif.lib libldapiconv.lib

# Use the following definition to link the sample programs with
# the LDAP shared library.  
CLIENT_LIBS = ldap.lib libldif.lib 
LDIR	= /LIBPATH:../lib
LFLAGS  = /nologo /subsystem:console /incremental:no  \
	$(LDIR) $(LIBS) $(CLIENT_LIBS)

#############################################################################
## Targets                                                                 ##
#############################################################################

all:	ldapsearch.exe ldapmodify.exe ldapdelete.exe ldapmodrdn.exe ldapadd.exe ldapchangepwd.exe ldapexop.exe

ldapsearch.exe:	ldapsearch.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapmodify.exe: ldapmodify.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapdelete.exe: ldapdelete.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapmodrdn.exe: ldapmodrdn.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapchangepwd.exe: ldapchangepwd.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapexop.exe: ldapexop.obj getopt.obj
	$(LD) $(LFLAGS) /out:$@ $**

ldapadd.exe:	ldapmodify.exe
	$(RM) $@
	$(HARDLN) ldapmodify.exe ldapadd.exe

clean:	
	$(RM) *.obj *.exe *.exp *.lib

.c.obj::
   $(CC) $(CFLAGS) /c $<

getopt.obj: getopt.c

ldapsearch.obj: ldapsearch.c

ldapmodify.obj: ldapmodify.c

ldapdelete.obj: ldapdelete.c

ldapmodrdn.obj: ldapmodrdn.c

ldapchangepwd.obj: ldapchangepwd.c

ldapexop.obj: ldapexop.c

