@echo off
set PATCH_TYPE=fix pack
set PATCH_NAME=5.2.0-TIV-ITDS-Win32-FP0004
set IDS_NAME=IBM Tivoli Directory Server v5.2
set IDS_EXE=ibmslapd
set IDS_DIRADM_NAME=ibmdiradm
title Uninstall %PATCH_TYPE% %PATCH_NAME%

if not "%1"=="/?" goto NO_HELP
echo This command will remove %PATCH_TYPE% %PATCH_NAME% for %IDS_NAME%
echo Use "no_prompt" to not prompt for confirmation or exit status.
goto :NO_EXT_END

rem =============================================================
:NO_HELP
rem these options bypass checking and should only be set when
rem called from the install.bat script to undo a failed install
if "%INSTALL_TYPE%"=="client" goto RESTORE
if "%INSTALL_TYPE%"=="server" goto RESTORE

rem Do not prompt for confirmation - just run
if "%1"=="no_prompt" goto START

echo This command will remove %PATCH_TYPE% %PATCH_NAME% for %IDS_NAME%
echo and restore the previous files.
echo.
echo Press ^<CTRL^>-C to cancel, or
pause

:START
VERIFY OTHER 2>nul
setlocal enableextensions
if not errorlevel 1 goto EXTENSIONS_ENABLED
echo.
echo CMD.EXE must support command extensions
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%1"=="no_prompt" pause
goto END

rem =============================================================
:EXTENSIONS_ENABLED
if "%1"=="no_prompt" set NO_PROMPT=TRUE
if exist rejectPatch.bat goto FOUND_PATCH_DIR
( pushd "%~dp0" 2>NUL ) && goto FOUND_PATCH_DIR
echo Unable to change to the directory where the where %PATCH_NAME%.zip was extracted.
echo Please change to that directory before running uninstall.
echo.
echo The %PATCH_TYPE% will not be uninstalled.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:FOUND_PATCH_DIR
if exist data\UNDO goto FOUND_UNDO
echo Unable to locate the data\UNDO directory
echo.
echo The %PATCH_TYPE% will not be uninstalled.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:FOUND_UNDO
if exist "%LDAPHome%" goto RESTORE
echo Unable to locate LDAP install directory
echo LDAPHome = %LDAPHome%
echo The %PATCH_TYPE% will not be uninstalled.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:RESTORE
if exist data\undo_files.list goto ABORT_INSTALL

    echo Uninstalling %PATCH_TYPE% %PATCH_NAME% for %IDS_NAME%...
    echo.

del /f /q data\error.txt 2>NUL
for /F %%f in (data\all_files.list) do call :RESTORE_FILE %%f
if exist data\error.txt goto RESTORE_ERROR
echo Removing %LDAPHome%\bin\%PATCH_NAME%*.*
del /f /q "%LDAPHome%\bin\%PATCH_NAME%*.*" 2>NUL
del /f /q data\installed_files.list 2>NUL

    echo.
    echo %PATCH_NAME% for %IDS_NAME% has been successfully uninstalled.
    echo.

if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:ABORT_INSTALL
rem echo Aborting install of %PATCH_TYPE% %PATCH_NAME%...
rem pause
del /f /q data\error.txt 2>NUL
for /F %%f in (data\undo_files.list) do call :RESTORE_FILE %%f
if exist data\error.txt goto RESTORE_ERROR
del /f /q data\undo_files.list 2>NUL
del /f /q "%LDAPHome%\bin\%PATCH_NAME%*.*" 2>NUL

if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:RESTORE_FILE
if exist data\error.txt goto :eof
if not exist "data\UNDO\%1" goto :eof
echo Restoring %LDAPHome%\%1
echo copy /v "data\UNDO\%1" "%LDAPHome%\%1" >data\error.tmp
( (copy /v "data\UNDO\%1" "%LDAPHome%\%1" 2>&1) >>data\error.tmp ) || ren data\error.tmp error.txt
goto :eof

rem =============================================================
:RESTORE_ERROR
echo Unexpected error while restoring data\UNDO files:
echo ---------------------------------------
type data\error.txt
echo ---------------------------------------
echo.
echo Be sure all client and server processes are stopped before uninstalling the patch.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:END
popd
endlocal

:NO_EXT_END
